#+TITLE: Readme
#+AUTHOR: Emma Nora Theuer

* Overwiev
** What is this?
This is my project wallman. Wallman is a simple python program used for setting Dynamic Wallpapers on minimalist X11 Window Managers and Wayland compositors. The name is a reference to TomSka: [[https://www.youtube.com/watch?v=k4Q3qD93rgI&t=131s]]
This version is an early Alpha. As of now, it supports the most important features for my usecase, those being randomly selected wallpaper sets and wallpaper sets that change by the time of day. The program is not modular yet and I would expect a lot of bugs related to the configuration file. Just how it is, I'm working on it.
As such, please make absolutely sure you follow the instructions on how to write the config file very closely. I will implement better config handling with more meaningful error output in the future. For now, follow everything really closely and read the logs if needed. If you do that, it /should/ work.

** What can it do?
Wallman currently has three main features:
+ Reading configuration details from a TOML file
+ Choosing from a set of Wallpapers and then setting the rest of the wallpapers accordingly
+ Settings Wallpapers at a specific time of the day
+ Be controlled via a systray

* Installation
** Depedencies
*** Always Required
+ Python 3.11 or newer (Required because of tomllib)
+ APScheduler (Install python-apscheduler or APScheduler, depending on the package manager)
+ feh (Used for setting the wallpapers, hard dependency)
*** Optional
+ libnotify (for desktop notification support)
+ pillow (For systray support)
+ pystray (For systray support)
*** Build dependencies
+ setuptools
+ build


** Installing with package Manager
*** Gentoo
Gentoo support has been dropped for now, as I currently don't have a Gentoo system to build on.

*** Arch Linux
Wallman is available in the AUR. Install it using your favorite AUR helper (I'm using paru as an example here)
#+BEGIN_SRC shell
paru -Syu wallman
mkdir ~/.config/wallman
cp /etc/wallman/sample_config.toml ~/.config/wallman/wallman.toml
#+END_SRC
Simply edit the config file and you're done.

*** Others
I will potentially write a version for nixpkgs and will also bundle wallman as a flatpak.

** Installing with pip
Wallman is available on PyPI. Simply run:
#+BEGIN_SRC shell
pip install wallman
#+END_SRC

** Installing manually
+ Install libnotify and feh, (preferably, also install the python dependencies from there) from your package manager
#+BEGIN_SRC shell
git clone https://git.entheuer.de/emma/Wallman.git
cd Wallman/
pip install -r requirements.txt
pip install installer
sudo mkdir -p /var/log/wallman
sudo chmod 733 /var/log/wallman
touch /var/log/wallman
mkdir -p ~/.config/wallman
cp sample_config.toml ~/.config/wallman/wallman.toml
sudo mkdir -p /etc/wallman/
sudo cp -r icons /etc/wallman
sudo cp -r DefaultFallbackWallpaper /etc/wallman/DefaultFallbackWallpaper.jpg
python -m build
sudo python -m installer --destdir=/ dist/*.whl
#+END_SRC
+ Edit the sample config
+ Profit

* Configuration
This is a short guide on how to correctly configure wallman. Look in the sample config for additional context.
** TOML Dictionaries
First of all, the config file is structured via different TOML dictionaries. There are two TOML dictionaries: general and changing_times that must be present in every config. Aside from that, further dictionaries are needed depending on how wallman is configured. You need to create a dictionary with the name of each wallpaper set defined in the used_sets list (more on that later). You should probably just configure wallman by editing the sample config as it is by far the easiest way to do it.
*** general
In general, you need to always define 3 variables and you can optionally add three more:
+ enable_wallpaper_sets: bool
    A simple switch that states if you want to use different sets of wallpapers or not.
+ used_sets: list
    A list that includes the names of the wallpaper sets you want to use. If you want to use only one, the list should have one entry.
+ wallpapers_per_set: int
    The amount of wallpapers that you use in each set. It should be an integer.
+ Optional: notify: bool
    This defaults to "false". Enable to set send a desktop notification when the wallpaper is changed. The program will still work correctly, even if this option is not defined at all.
+ Optional: fallback_wallpaper: string
    Wallpaper to be set if an error is found in the config or the wallpaper intended to be set cannot be found. Defaults to "/etc/wallman/DefaultFallbackWallpaper.jpg". If none is set and the config has been written incorrectly, a ConfigError is raised and the program is exited. If an error in the config occurs but the fallback wallpaper has been defined, it will be set and wallman will raise a config error. If The config is written correctly but the wallpaper intended to be set can't be found, wallman will set the fallback wallpaper and continue to try setting future wallpapers. You can both change this location (recommended) or the wallpaper that the path points to.
+ Optional: loglevel: string
    Loglevel to be used by wallman. Defaults to INFO. Choices MUST be DEBUG, INFO, WARNING, ERROR or CRITICAL. Using any capitalization is valid, all caps is reccomended. Wallman will crash if a value is specified that is not one of the specified ones.
+ Optional: systray: bool
    This defaults to "true". This enables support for a systray that has the features to re-set your wallpaper (Mostly useful if feh shits itself or if you want to set the correct wallpaper for a specific time of day after your device was suspended) without rerolling the wallpaper set used, a button to reroll and then re-set the wallpaper, as well as a Quit button. Disable this to save a very tiny amount of memory.
+ Optional: behavior: string
    This defaults to ~--bg-fill~. This is also the value that will be used when an invalid configuration option has been set. This supports 6 different modes, each mode has 2 possible keywords, resulting in 12 total valid keywords.
    ~--bg~, ~plain~. What happens when feh is used with the ~--bg~ flag. Sets a wallpaper without any scaling.
    ~--bg-tile~, ~tile~. Sets the wallpaper only on one monitor, the other ones get filled with black or white. Mostly useful for Xinerama setups with overlapping monitors. Equivalent to ~--bg-tile~ in feh.
    ~--bg-center~, ~center~. Sets a wallpaper with the center of the wallpaper centered on the middle of the screen. Crops edges. Equivalent to ~--bg-center~ in feh.
    ~--bg-fill~, ~fill~ (Default). Fills the whole screen with the wallpaper and zooms to preserve the original aspect ratio. Equivalent to ~--bg-fill~ in feh.
    ~--bg-max~, ~max~. Scales the image to the maximum possible size. Equivalent to ~--bg-max~ in feh.
    ~--bg-scale~, ~scale~. Scales the wallpaper to fill the screen, but does not preserve the original aspect ratio. Leads to squishing if aspect ratio of screen and wallpaper don't match. Equivalent to ~--bg-scale~ in feh.


*** changing_times
The changing_times dictionary is used to specify the times of the day when your wallpaper is switched. The names of the keys do not matter here, the values must always be strings in the "XX:YY:ZZ" 24 hour time system. use 00:00:00 for midnight. Note that XX should be in the range of 00-23 and YY and ZZ should be in the range of 00-59.

*** The other dictionaries
The other dictionaries must always have the names of the wallpaper sets from used_sets. If you have one wallpaper set, you need one additional dictionary, if you have two you need two etc. The standard config uses nature and anime, these names can be whatever you please as long as they are the same as the ones specified in used_sets.
The keys in the dictionary once again do not matter, the names of the keys in each dictionary must be strings and be absolute paths. They should not include spaces unless prefaced by a backslash.


*  TODOs
** Structuring
+ Write unittests
+ Add documentation for developers

** Technical Details
+ Improve Modularity (Partially done)
+ Drop the feh dependecy and set wallpapers using pywlroots or python-xlib

** Features
+ Add support for wallpapers that dynamically change with the time of day (Morning, noon, evening, night or light levels) rather than to times set in the config
+ Add support for wallpapers that change by the weather
+ Add support for live wallpapers
